#!/bin/sh
# $Id: caps.sh,v 1.1.1.1 2014/05/01 19:46:36 rkiesling Exp $
#
# This is how we will get system capabilities into classes/ctalklib.
# Instead of writing a library function for every capability (although
# it's possible to do that also), 
#
# Note that this is not well tested, so we also keep a basic ctalklib 
# (with these capabilities defined as 0) so that if the caps.h script 
# doesn't work right, it won't break any builds.
#

# First, start with ctalklib with no capabilities set.
cat classes/ctalklib.in > classes/ctalklib

# Set the HAVE_GNU_READLINE #define if the machine has GNU 
# readline.
cap=`grep 'HAVE_GNU_READLINE 1' config.h`
if [ "$cap" != "" ]; then
    sed 's/#define HAVE_GNU_READLINE 0/#define HAVE_GNU_READLINE 1/' classes/ctalklib >classes/ctalklib.out
mv classes/ctalklib.out classes/ctalklib
fi

# Do the same with HAVE_X_H
cap=`grep 'HAVE_X_H 1' config.h`
if [ "$cap" != "" ]; then
    sed 's/#define HAVE_X_H 0/#define HAVE_X_H 1/' classes/ctalklib >classes/ctalklib.out
mv classes/ctalklib.out classes/ctalklib
fi

