#!/bin/sh

help () {
    echo "Usage: lcflags \"CTALKFLAGS\" \"CFLAGS\" \"OPTIMIZINGFLAGS\" \"LDFLAGS\""
    echo "   Configures default compile and link options for ctcc(1) and ctdb(1)."
    exit 1;
}

if [ $# -ne 4 ] ; then help; fi

ctalkflags=`echo $1 | sed s/\"//g | sed s/-/\\\-/g`
cflags=`echo $2 | sed s/\"//g`
optflags=`echo $3 | sed s/\"//g`
ldflags=`echo $4 | sed s/\"//g`

cat src/ctcc.in | sed -e "s|@ac_ctalkflags@|$ctalkflags|" | \
    sed "s|@ac_cflags@|$cflags|" | \
    sed "s|@ac_optflags@|$optflags|" | \
    sed "s|@ac_ldflags@|$ldflags|" > src/ctcc

cat src/ctdb.in | sed -e "s|@ac_ctalkflags@|$ctalkflags|" | \
    sed "s|@ac_cflags@|$cflags|" | \
    sed "s|@ac_ldflags@|$ldflags|" > src/ctdb

cat test/expect/cttest.in | sed -e "s|@ac_ctalkflags@|$ctalkflags|" | \
    sed "s|@ac_cflags@|$cflags|" | \
    sed "s|@ac_ldflags@|$ldflags|" > test/expect/cttest

