#!/bin/sh

SEARCHDIRS_FILE=include/searchdirs.h
echo Creating $SEARCHDIRS_FILE
echo "/* This is a machine generated file.  Do not edit! */" > $SEARCHDIRS_FILE
echo >>$SEARCHDIRS_FILE
echo char *searchdirs[] = { >> $SEARCHDIRS_FILE

CPPOUT=`echo ' ' | cpp -E -v - 2>&1`
EXPR=`which expr`

if [ -z '$CPPOUT' ]; then
    echo 'include_dirs.sh: Cannot run "cpp -E -v:" See cpp(1). Exiting'
    exit 1
fi

if [ -z $EXPR ]; then
    echo 'include_dirs.sh: Cannot find "expr:" See expr(1). Exiting.'
    exit 1
fi

SEARCHDIRS=""
SEARCHDIR_OUT=""
N_PATHS=0

for i in $CPPOUT; do
    if [ -d $i ]; then 
	echo \"$i\", >>$SEARCHDIRS_FILE;
 	SEARCHDIR_OUT=$SEARCHDIR_OUT"\n$i"
	N_PATHS=$(expr $N_PATHS + 1)
    fi 
done

echo '(void *)0' >>$SEARCHDIRS_FILE
echo '};' >>$SEARCHDIRS_FILE
echo '#define N_PATHS '$N_PATHS >>$SEARCHDIRS_FILE

SEARCHDIR_OUT=$SEARCHDIR_OUT"\n"

echo $SEARCHDIR_OUT >include_dirs.out

