int main (int argv, char **argc) {
  X11Pane new xPane;
  X11PaneDispatcher new xTopLevelPane;
  X11TextPane new xTextPane;
  InputEvent new e;
  Integer new nEvents;
  Integer new verbose;
  Exception new ex;
  String new text;

  xPane initialize 25, 30, 200, 100;
  xTopLevelPane attachTo xPane;
  xTextPane attachTo xTopLevelPane;
  xPane map;
  xPane raiseWindow;

  xPane openEventStream;

  xTextPane font "-*-courier-medium-r-*-*-12-120-*-*-*-*-*-*";

  verbose = FALSE;
  if (argc == 2) {
    if (!strcmp (argv[1], "-v")) {
      verbose = TRUE;
    }
  }

  if (verbose)
    printf ("Font: %s\n", xTextPane fontDescStr);

  WriteFileStream classInit;

  xTextPane background "white";
  /* 
   * When received before the input loop, "clear," 
   * blanks out the pane's buffers, but it does not
   * visibly update the window.  That is the purpose
   * of the, "subPaneExpose," event, which is called
   * automatically whenever the X11PaneDispatcher
   * parent receives an, "Expose," event from the 
   * GUI.
   */
  xTextPane clear;

  xTextPane appendLine "Hello, world!";
  xTextPane appendLine "Hello, world again! 1";
  xTextPane appendLine "Hello, world again! 2";
  xTextPane appendLine "Hello, world again! 3";
  xTextPane appendLine "Hello, world again! 4";
  xTextPane appendLine "Hello, world again! 5";
  xTextPane appendLine "Hello, world again! 6";
  xTextPane appendLine "Hello, world again! 7";
  xTextPane appendLine "Hello, world again! 8";
  xTextPane appendLine "Hello, world again! 9";
  xTextPane appendLine "Hello, world again! 10";

  xTextPane displayText;

  while (TRUE) {
    xPane inputStream queueInput;
    if (xPane inputStream eventPending) {
      e become xPane inputStream inputQueue unshift;
      xPane subPaneNotify e;
      if (ex pending)
 	ex handle;
      switch (e eventClass value) 
	{
	  /*
	   *  Handle both types of events in case the window
	   *  manager doesn't distinguish between them.
	   */
	case MOVENOTIFY:
	  if (verbose) {
	    stdoutStream printOn "MOVENOTIFY\t%d\t%d\t%d\t%d\n",
	      e xEventData1, 
	      e xEventData2, 
	      e xEventData3, 
	      e xEventData4;
	    stdoutStream printOn "Window\t\t%d\t%d\t%d\t%d\n",
	      xPane origin x, 
	      xPane origin y, 
	      xPane size x,
	      xPane size y;
	  }
	  break;
	case RESIZENOTIFY:
	  if (verbose) {
	    stdoutStream printOn "RESIZENOTIFY\t%d\t%d\t%d\t%d\n",
	      e xEventData1, 
	      e xEventData2, 
	      e xEventData3, 
	      e xEventData4;
	    stdoutStream printOn "Window\t\t%d\t%d\t%d\t%d\n",
	      xPane origin x, 
	      xPane origin y, 
	      xPane size x,
	      xPane size y;
	  }
	  break;
	case EXPOSE:
	  if (verbose) {
	    stdoutStream printOn "Expose\t\t%d\t%d\t%d\t%d\t%d\n",
	      e xEventData1, 
	      e xEventData2, 
	      e xEventData3, 
	      e xEventData4,
	      e xEventData5;
	  }
	  break;
	  /*
	   *  Blade 150:
	   *  Cursor UP:
	   *  KeyPress                132     70      0       89      0
	   *  KeyRelease              132     70      0       89      0
	   *  Cursor DOWN:
	   *  KeyPress                132     70      0       88      0
	   *  KeyRelease              132     70      0       88      0
	   *  Cursor RIGHT:
	   *  KeyPress                132     70      0       86      0
	   *  KeyRelease              132     70      0       86      0
	   *  Cursor LEFT:
	   *  KeyPress                132     70      0       87      0
	   *  KeyRelease              132     70      0       87      0
	   *  
	   *  Opti
	   *  Cursor UP:
	   *  KeyPress		69	7	0	98	0
	   *  KeyRelease	69	7	0	98	0
	   *  Cursor DOWN:
	   *  KeyPress		69	7	0	104	0
	   *  KeyRelease	69	7	0	104	0
	   *  Cursor RIGHT:
	   *  KeyPress		69	7	0	102	0
	   *  KeyRelease	69	7	0	102	0
	   *  Cursor LEFT:
	   *  KeyPress		69	7	0	100	0
	   *  KeyRelease	69	7	0	100	0
	   */
	case KEYPRESS:
	  break;
	case KEYRELEASE:
	  break;
	case WINDELETE:
 	  xPane deleteAndClose;
	  exit (0);
	  break;
	default:
	  break;
	}
    }
  }
}
