int main (int argv, char **argc) {
  X11Pane new xPane;
  X11PaneDispatcher new xTopLevelPane;
  X11TextPane new xTextPane;
  InputEvent new e;
  Integer new nEvents;
  Integer new verbose;
  Exception new ex;
  String new text;
  Application new paneApp;

  paneApp enableExceptionTrace;
  paneApp installExitHandlerBasic;

  xPane initialize 25, 30, 200, 100;
  xTopLevelPane attachTo xPane;
  xTextPane attachTo xTopLevelPane;
  xPane map;
  xPane raiseWindow;

  xTextPane useFont "-*-courier-medium-r-*-*-12-120-*-*-*-*-*-*";

  xPane openEventStream;

  verbose = FALSE;
  if (argc == 2) {
    if (!strcmp (argv[1], "-v")) {
      verbose = TRUE;
    }
  }

  if (verbose)
    printf ("Actual font: %s\n", xPane font fontDesc);

  WriteFileStream classInit;

  xTextPane appendLine "Hello, world!";
  xTextPane appendLine "Hello, world again! 1";
  xTextPane appendLine "Hello, world again! 2";
  xTextPane appendLine "Hello, world again! 3";
  xTextPane appendLine "Hello, world again! 4";
  xTextPane appendLine "Hello, world again! 5";
  xTextPane appendLine "Hello, world again! 6";
  xTextPane appendLine "Hello, world again! 7";
  xTextPane appendLine "Hello, world again! 8";
  xTextPane appendLine "Hello, world again! 9";
  xTextPane appendLine "Hello, world again! 10";

  while (TRUE) {
    xPane inputStream queueInput;
    if (xPane inputStream eventPending) {
      e become xPane inputStream inputQueue unshift;
      xPane subPaneNotify e;
      if (ex pending)
 	ex handle;
      switch (e eventClass value) 
	{
	  /*
	   *  Handle both types of events in case the window
	   *  manager doesn't distinguish between them.
	   */
	case MOVENOTIFY:
	  if (verbose) {
	    stdoutStream printOn "MOVENOTIFY\t%d\t%d\t%d\t%d\n",
	      e xEventData1, 
	      e xEventData2, 
	      e xEventData3, 
	      e xEventData4;
	    stdoutStream printOn "Window\t\t%d\t%d\t%d\t%d\n",
	      xPane origin x, 
	      xPane origin y, 
	      xPane size x,
	      xPane size y;
	  }
	  break;
	case RESIZENOTIFY:
	  if (verbose) {
	    stdoutStream printOn "RESIZENOTIFY\t%d\t%d\t%d\t%d\n",
	      e xEventData1, 
	      e xEventData2, 
	      e xEventData3, 
	      e xEventData4;
	    stdoutStream printOn "Window\t\t%d\t%d\t%d\t%d\n",
	      xPane origin x, 
	      xPane origin y, 
	      xPane size x,
	      xPane size y;
	  }
	  break;
	case EXPOSE:
	  if (verbose) {
	    stdoutStream printOn "Expose\t\t%d\t%d\t%d\t%d\t%d\n",
	      e xEventData1, 
	      e xEventData2, 
	      e xEventData3, 
	      e xEventData4,
	      e xEventData5;
	  }
	  break;
	case KEYPRESS:
	  break;
	case KEYRELEASE:
	  break;
	case WINDELETE:
 	  xPane deleteAndClose;
	  exit (0);
	  break;
	default:
	  break;
	}
    }
  }
}
